| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | Static Public Member Functions | List of all members
Ogre::DDSCodec Class Reference
Core » Image

Codec specialized in loading DDS (Direct Draw Surface) images. More...

`#include <OgreDDSCodec.h>`

Inheritance diagram for Ogre::DDSCodec:
[legend]

## Public Types
typedef SharedPtr< CodecData > | CodecDataPtr
typedef ConstMapIterator< CodecList > | CodecIterator
typedef std::pair< MemoryDataStreamPtr, CodecDataPtr > | DecodeResult
| Result of a decoding; both a decoded data stream and CodecData metadata. More...

## Public Member Functions
| DDSCodec ()
virtual | ~DDSCodec ()
DecodeResult | decode (const DataStreamPtr &input) const
| Codes the data from the input chunk into the output chunk. More...
DataStreamPtr | encode (const MemoryDataStreamPtr &input, const CodecDataPtr &pData) const
| Codes the data in the input stream and saves the result in the output stream. More...
void | encodeToFile (const MemoryDataStreamPtr &input, const String &outFileName, const CodecDataPtr &pData) const
| Codes the data in the input chunk and saves the result in the output filename provided. More...
String | getDataType () const
| Returns the type of the data that supported by this codec as a String. More...
virtual String | getType () const
| Returns the type of the codec as a String. More...
virtual bool | magicNumberMatch (const char *magicNumberPtr, size_t maxbytes) const
| Returns whether a magic number header matches this codec. More...
String | magicNumberToFileExt (const char *magicNumberPtr, size_t maxbytes) const
| Maps a magic number header to a file extension, if this codec recognises it. More...

## Static Public Member Functions
static Codec * | getCodec (const String &extension)
| Gets the codec registered for the passed in file extension. More...
static Codec * | getCodec (char *magicNumberPtr, size_t maxbytes)
| Gets the codec that can handle the given 'magic' identifier. More...
static CodecIterator | getCodecIterator (void)
| Gets the iterator for the registered codecs. More...
static StringVector | getExtensions (void)
| Gets the file extension list for the registered codecs. More...
static bool | isCodecRegistered (const String &codecType)
| Return whether a codec is registered already. More...
static void | registerCodec (Codec *pCodec)
| Registers a new codec in the database. More...
static void | shutdown (void)
| Static method to shutdown and unregister the DDS codec. More...
static void | startup (void)
| Static method to startup and register the DDS codec. More...
static void | unregisterCodec (Codec *pCodec)
| Unregisters a codec from the database. More...

## Detailed Description

Codec specialized in loading DDS (Direct Draw Surface) images.

Remarks
  We implement our own codec here since we need to be able to keep DXT data compressed if the card supports it.

## Member Typedef Documentation

## ◆ CodecDataPtr

typedef SharedPtr<CodecData> Ogre::Codec::CodecDataPtr
| inherited

## ◆ CodecIterator

typedef ConstMapIterator<CodecList> Ogre::Codec::CodecIterator
| inherited

## ◆ DecodeResult

typedef std::pair<MemoryDataStreamPtr, CodecDataPtr> Ogre::Codec::DecodeResult
| inherited

Result of a decoding; both a decoded data stream and CodecData metadata.

## Constructor & Destructor Documentation

## ◆ DDSCodec()

Ogre::DDSCodec::DDSCodec | ( |  | ) |

## ◆ ~DDSCodec()

virtual Ogre::DDSCodec::~DDSCodec | ( |  | ) |
| inline virtual

## Member Function Documentation

## ◆ encode()

DataStreamPtr Ogre::DDSCodec::encode | ( | const MemoryDataStreamPtr & | input,
|  | const CodecDataPtr & | pData
| ) |  | const
| virtual

Codes the data in the input stream and saves the result in the output stream.

Implements Ogre::Codec.

## ◆ encodeToFile()

void Ogre::DDSCodec::encodeToFile | ( | const MemoryDataStreamPtr & | input,
|  | const String & | outFileName,
|  | const CodecDataPtr & | pData
| ) |  | const
| virtual

Codes the data in the input chunk and saves the result in the output filename provided.

Provided for efficiency since coding to memory is progressive therefore memory required is unknown leading to reallocations.

Parameters

  input | The input data
  outFileName | The filename to write to
  pData | Extra information to be passed to the codec (codec type specific)

Implements Ogre::Codec.

## ◆ decode()

DecodeResult Ogre::DDSCodec::decode | ( | const DataStreamPtr & | input | ) | const
| virtual

Codes the data from the input chunk into the output chunk.

Parameters

  input | Stream containing the encoded data

Implements Ogre::Codec.

## ◆ magicNumberToFileExt()

String Ogre::DDSCodec::magicNumberToFileExt | ( | const char * | magicNumberPtr,
|  | size_t | maxbytes
| ) |  | const
| virtual

Maps a magic number header to a file extension, if this codec recognises it.

Parameters

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  maxbytes | The number of bytes passed

Returns
  A blank string if the magic number was unknown, or a file extension.

Implements Ogre::Codec.

## ◆ getType()

virtual String Ogre::DDSCodec::getType | ( |  | ) | const
| virtual

Returns the type of the codec as a String.

Implements Ogre::Codec.

## ◆ startup()

static void Ogre::DDSCodec::startup | ( | void |  | ) |
| static

Static method to startup and register the DDS codec.

## ◆ shutdown()

static void Ogre::DDSCodec::shutdown | ( | void |  | ) |
| static

Static method to shutdown and unregister the DDS codec.

## ◆ getDataType()

String Ogre::ImageCodec::getDataType | ( |  | ) | const
| inline virtual inherited

Returns the type of the data that supported by this codec as a String.

Implements Ogre::Codec.

## ◆ registerCodec()

static void Ogre::Codec::registerCodec | ( | Codec * | pCodec | ) |
| inline static inherited

Registers a new codec in the database.

References Ogre::Exception::ERR_DUPLICATE_ITEM, Ogre::Codec::getType(), and OGRE_EXCEPT.

## ◆ isCodecRegistered()

static bool Ogre::Codec::isCodecRegistered | ( | const String & | codecType | ) |
| inline static inherited

Return whether a codec is registered already.

## ◆ unregisterCodec()

static void Ogre::Codec::unregisterCodec | ( | Codec * | pCodec | ) |
| inline static inherited

Unregisters a codec from the database.

References Ogre::Codec::getType().

## ◆ getCodecIterator()

static CodecIterator Ogre::Codec::getCodecIterator | ( | void |  | ) |
| inline static inherited

Gets the iterator for the registered codecs.

## ◆ getExtensions()

static StringVector Ogre::Codec::getExtensions | ( | void |  | ) |
| static inherited

Gets the file extension list for the registered codecs.

## ◆ getCodec() [1/2]

static Codec* Ogre::Codec::getCodec | ( | const String & | extension | ) |
| static inherited

Gets the codec registered for the passed in file extension.

## ◆ getCodec() [2/2]

static Codec* Ogre::Codec::getCodec | ( | char * | magicNumberPtr,
|  | size_t | maxbytes
| ) |  |
| static inherited

Gets the codec that can handle the given 'magic' identifier.

Parameters

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  maxbytes | The number of bytes passed

## ◆ magicNumberMatch()

virtual bool Ogre::Codec::magicNumberMatch | ( | const char * | magicNumberPtr,
|  | size_t | maxbytes
| ) |  | const
| inline virtual inherited

Returns whether a magic number header matches this codec.

Parameters

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  maxbytes | The number of bytes passed

The documentation for this class was generated from the following file:

- OgreDDSCodec.h